package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.entity.interfaces.ExternalAccess;
import cz.fi.muni.pa165.entity.interfaces.Viewable;
import cz.fi.muni.pa165.enums.CountryEnum;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import java.util.ArrayList;
import java.util.Date;

/**
 * @author mvalko
 */

@Entity
@Data
public class PersonEntity extends BaseEntity implements ExternalAccess, Viewable {

    @Column(nullable = false)
    private String name;

    private Date birth;

    private CountryEnum country;

    public PersonEntity() {
    }

    public PersonEntity(String name){
        this.name = name;
    }

    public PersonEntity(String name, Date birth, CountryEnum country){
        this(name);

        this.birth = birth;
        this.country = country;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getBirth() {
        return birth;
    }

    public void setBirth(Date birth) {
        this.birth = birth;
    }

    public CountryEnum getCountry() {
        return country;
    }

    public void setCountry(CountryEnum country) {
        this.country = country;
    }

    public String getConcreteInformation(){
        return null;
    }

    @Override
    public boolean login() {
        return false;
    }

    @Override
    public boolean changePassword() {
        return false;
    }

    @Override
    public ArrayList<String> getInformation() {
        return null;
    }
}
