package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.entity.interfaces.Viewable;
import cz.fi.muni.pa165.enums.CountryEnum;
import org.hibernate.annotations.CollectionId;

import javax.persistence.*;
import java.util.ArrayList;

/**
 * @author mvalko
 */

@Entity
public class TeamEntity extends BaseEntity implements Viewable {

    @Column(nullable = false, unique = true)
    private String name;
    private CountryEnum country;
    @OneToMany
    private ArrayList<PlayerEntity> playerList;
    @ManyToMany
    private ArrayList<TournamentEntity> completedTournaments;
    @ManyToMany
    private ArrayList<TournamentEntity> plannedTournaments;
    @OneToOne
    private TeamManagerEntity manager;

    public TeamEntity(){

    }

    public TeamEntity(String name, TeamManagerEntity manager){
        this.name = name;
        this.manager = manager;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public CountryEnum getCountry() {
        return country;
    }

    public void setCountry(CountryEnum country) {
        this.country = country;
    }

    public ArrayList<PlayerEntity> getPlayerList() {
        return playerList;
    }

    public void setPlayerList(ArrayList<PlayerEntity> playerList) {
        this.playerList = playerList;
    }

    public ArrayList<TournamentEntity> getCompletedTournaments() {
        return completedTournaments;
    }

    public void setCompletedTournaments(ArrayList<TournamentEntity> completedTournaments) {
        this.completedTournaments = completedTournaments;
    }

    public ArrayList<TournamentEntity> getPlannedTournaments() {
        return plannedTournaments;
    }

    public void setPlannedTournaments(ArrayList<TournamentEntity> plannedTournaments) {
        this.plannedTournaments = plannedTournaments;
    }

    public void addPlayerToTheTeam(PlayerEntity newPlayer){
        this.playerList.add(newPlayer);
    }

    @Override
    public ArrayList<String> getInformation() {
        return null;
    }
}
