package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.entity.interfaces.Viewable;
import cz.fi.muni.pa165.enums.CountryEnum;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToMany;
import java.util.ArrayList;

/**
 * @author mvalko
 */

@Entity
public class TournamentEntity extends BaseEntity implements Viewable {

    @Column(nullable = false, unique = true)
    private String place;
    private CountryEnum country;
    private double prizePool;
    @ManyToMany
    private ArrayList<TeamEntity> teamsEnrolled;
    private TournamentFormat tournamentFormat;
    private int teamCapacity;

    public TournamentEntity() {
    }

    public TournamentEntity(String place, CountryEnum country,
                            int pricePool, TournamentFormat format, int capacity) {

        this.place = place;
        this.country = country;
        this.prizePool = pricePool;
        this.tournamentFormat = format;
        this.teamCapacity = capacity;
    }

    private void shuffleTeamsToFormat(){}

    public boolean addTeamToTournament(TeamEntity team){
        if (teamsEnrolled.size() < teamCapacity) {
            teamsEnrolled.add(team);
            return true;
        }

        return false;
    }

    public void signTeamForTournament(TeamEntity team){

    }

    @Override
    public ArrayList<String> getInformation() {
        return null;
    }
}
